-- -------------------------------------------------
-- Filename: 54002.sql
--
-- Script file for PL/SQL 101 for Oracle 10g
-- Chapter 02
-- Created by Christopher Allen
-- Copyright Oracle Press (c) 2004
-- -------------------------------------------------


-- Figure 2-1
CREATE TABLE plsql101_test_1 (
     first_name CHAR(15), 
     last_name  CHAR(20)
     )
;



-- Figure 2-2
INSERT INTO plsql101_test_1 VALUES ('Jane', 'Smith');



-- Command in text not in a figure
INSERT INTO plsql101_test_1 VALUES ('Christopher', 'Allen');


-- Figure 2-3
SELECT * FROM plsql101_test_1;


-- Figure 2-4
DROP TABLE plsql101_test_1;


-- Figure 2-5
SELECT * FROM plsql101_test_1;


-- Figure 2-6
CREATE TABLE plsql101_test_2 ( 
     name   VARCHAR2(20), 
     gender CHAR(1) 
     )
;

INSERT INTO plsql101_test_2 VALUES ('George', 'M');
INSERT INTO plsql101_test_2 VALUES ('Jane', 'F');

SELECT * FROM plsql101_test_2;

DROP TABLE plsql101_test_2;



-- Figure 2-7
CREATE TABLE plsql101_product ( 
     product_name  VARCHAR2(25), 
     product_price NUMBER(4,2)
     )
;

INSERT INTO plsql101_product VALUES ('Product Name 1', 1);
INSERT INTO plsql101_product VALUES ('Product Name 2', 2.5);
INSERT INTO plsql101_product VALUES ('Product Name 3', 50.75);
INSERT INTO plsql101_product VALUES ('Product Name 4', 99.99);
 
SELECT * FROM plsql101_product;

DROP TABLE plsql101_product;



-- Figure 2-8
CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25), 
     product_price NUMBER(4,2),
     purchase_date DATE
     )
;

INSERT INTO plsql101_purchase VALUES 
     ('Product Name 1', 1, '5-NOV-03');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 2', 2.5, '29-JUN-04');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 3', 50.75, '10-DEC-05');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 4', 99.99, '31-AUG-06');



-- Figure 2-9
DESC plsql101_purchase



-- Figure 2-10
DROP TABLE plsql101_purchase;

CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25) NOT NULL, 
     product_price NUMBER(4,2)  NOT NULL,
     purchase_date DATE         
     )
;



-- Figure 2-11
INSERT INTO plsql101_purchase VALUES ('Product Name 1', 1, NULL);

SELECT * FROM plsql101_purchase;



-- Figure 2-12
INSERT INTO plsql101_purchase VALUES 
     (NULL, 2.5, '29-JUN-04');
INSERT INTO plsql101_purchase VALUES  
     ('Product Name 3', null, '10-DEC-05');
INSERT INTO plsql101_purchase VALUES 
     (NULL, NULL, '31-AUG-06');

SELECT * FROM plsql101_purchase;



-- Figure 2-13
INSERT INTO plsql101_purchase (product_name, product_price) 
     VALUES ('Product Name 2', 2.5);
INSERT INTO plsql101_purchase (product_name, product_price) 
     VALUES ('Product Name 3', 50.75);
INSERT INTO plsql101_purchase (product_price, product_name) 
     VALUES (99.99, 'Product Name 4');

SELECT * FROM plsql101_purchase;



-- Figure 2-14
INSERT INTO plsql101_purchase VALUES 
     ('Fifth Product's Name', 25, '05-MAY-06');



-- Figure 2-15
SET SCAN OFF
INSERT INTO plsql101_purchase VALUES 
     ('Fifth Product''s Name', 25, '05-MAY-06');
SET SCAN ON

SELECT * FROM plsql101_purchase;



-- Figure 2-16
SELECT product_name FROM plsql101_purchase;



-- Figure 2-17
SELECT purchase_date, product_price, product_name 
FROM   plsql101_purchase;



-- Figure 2-18
SELECT product_name, product_price * 1.15 FROM plsql101_purchase;



-- Prep for figure 2-19
DROP TABLE plsql101_purchase;

CREATE TABLE plsql101_purchase ( 
     product_name  VARCHAR2(25), 
     product_price NUMBER(4,2),
     sales_tax     NUMBER(4,2),
     purchase_date DATE, 
     salesperson   VARCHAR2(3)
     )
;

INSERT INTO plsql101_purchase VALUES 
     ('Product Name 1', 1, .08, '5-NOV-04', 'AB');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 2', 2.5, .21, '29-JUN-05', 'CD');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 3', 50.75, 4.19, '10-DEC-06', 'EF');
INSERT INTO plsql101_purchase VALUES 
     ('Product Name 4', 99.99, 8.25, '31-AUG-07', 'GH');



-- Figure 2-19
SELECT product_name, product_price + sales_tax FROM plsql101_purchase;
SELECT product_name, 100 - product_price FROM plsql101_purchase;
SELECT product_name, sales_tax / product_price FROM plsql101_purchase;



-- Figure 2-20
SELECT product_name || ' was sold by ' || salesperson
FROM   plsql101_purchase;



-- Figure 2-21
SELECT product_name || ' was sold by ' || salesperson "Sold By"
FROM   plsql101_purchase;
